(in-package :oou)
(oou-provide :P4200-vp)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; P4200-vp.lisp
;;
;; Copyright  1991 Northwestern University Institute for the Learning Sciences
;; All Rights Reserved
;;
;; author: Michael S. Engber
;;
;; video player class for Pioneer model 4200 laserdisc players
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(oou-dependencies
 :Pioneer-vp
 )

(export '(P4200-vp))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defclass P4200-vp (Pioneer-vp) ())


(defmethod vp-features ((vp P4200-vp))
  (when (eq (disk-format vp) :CAV) '(:freeze :step :scan)))

(defmethod vp-freeze ((vp P4200-vp))
  (when (eq (disk-format vp) :CAV)
    (call-next-method)))

(defmethod vp-step ((vp P4200-vp) direction)
  (declare (ignore direction))
  (when (eq (disk-format vp) :CAV)
    (call-next-method)))

(defmethod vp-scan ((vp P4200-vp) direction speed-x)
  (declare (ignore end-frame direction speed-x))
  (when (eq (disk-format vp) :CAV)
    (call-next-method)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defmethod pld-address-format ((ld P4200-vp) disk-format)
  (ecase disk-format
    (:CAV :frame)
    (:CLV :hmmss)
    (:CLV-E :hmmss)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
