(in-package :oou)
(oou-provide :P8000-vp)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; P8000-vp.lisp
;;
;; Copyright  1991 Northwestern University Institute for the Learning Sciences
;; All Rights Reserved
;;
;; author: Michael S. Engber
;;
;; video player class for Pioneer model 8000 laserdisc players
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(oou-dependencies
 :Pioneer-vp
 )

(export '(P8000-vp))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defclass P8000-vp (Pioneer-vp) ())

(defmethod vp-features ((vp P8000-vp))
  (if (eq (disk-format vp) :CLV)
    '(:freeze)
    '(:freeze :step :scan)))

(defmethod vp-step ((vp P8000-vp) direction)
  (declare (ignore direction))
  (unless (eq (disk-format vp) :CLV)
    (call-next-method)))

(defmethod vp-scan ((vp P8000-vp) direction speed-x)
  (declare (ignore direction speed-x))
  (unless (eq (disk-format vp) :CLV)
    (call-next-method)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defmethod pld-address-format ((vp P8000-vp) disk-format)
  (ecase disk-format
    (:CAV   :frame)
    (:CLV   :hmmss)
    (:CLV-E :hmmssff)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#|
;a more interesting example can be found in Pioneer-vp.lisp

(setf vp (make-instance 'P8000-vp
               :disk-format :CLV-E))

(vp-init vp)

(vp-play vp)
(vp-stop vp)
(vp-freeze vp)
(vp-step vp)

(vp-current-frame vp)

(progn
  (vp-seek vp 4500)
  (vp-scan vp :speed-x 4))

(progn
  (vp-seek vp 5000)
  (vp-scan vp :direction :reverse :speed-x 4))

|#